local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local buff = x.Buff
local dot = x.Dot
local cooldown = x.Cooldown
local talent = x.Talent
local equipped = x.Equipped
local target = x.Target
local debuff = x.Debuff

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()

	a.UpdateRunes()
	s.UpdateTarget()

	x.RunicPower = UnitPower("player", Enum.PowerType.RunicPower)
	x.RunicPowerDeficit = s.MaxPower("player", Enum.PowerType.RunicPower) - x.RunicPower

	x.InCombat = s.InCombat()
	x.GCD = s.GlobalCooldown()
	x.Spec = s.TalentMastery()
	x.MaxHealth = s.MaxHealth("player")
	x.Health = s.Health("player")
	x.HealthPercent = s.HealthPercent("player")
	x.ActiveEnemies = s.SpellTargets()
	x.Time = s.Time()
	x.Haste = 1 + UnitSpellHaste("player") / 100
	x.MaxGCD = 1.5 / x.Haste
	if x.MaxGCD < 1 then
		x.MaxGCD = 1
	end
	x.UseLongCD = x.InCombat and (s.Boss("target") or x.InstanceType == "pvp" or x.InstanceType == "arena" or (tostring(UnitClassification("target")):lower():match("elite") and x.InstanceType == "none"))

	if x.Spec == 1 then
		-- Blood

		if s.Channeling(206931--[[Blooddrinker]], "player") then
			return
		end

		s.UpdateBuff(77535, "Blood Shield")
		s.UpdateBuff(81256, "Dancing Rune Weapon")
		s.UpdateBuff(81141, "Crimson Scourge")
		s.UpdateBuff(195181, "Bone Shield")
		s.UpdateBuff(235559, "Haemostasis")
		s.UpdateDoT(55078, "Blood Plague")

		s.UpdateCooldown(206931, "Blooddrinker")
		s.UpdateCooldown(50842, "Blood Boil")

		a.Flash("dark_command")

		a.Flash("auto_attack"
				,"mind_freeze"
				,"arcane_torrent,if=runic_power.deficit>20"
				,"blood_fury"
				,"berserking,if=buff.dancing_rune_weapon.up"
--				,"use_items"
--				,"potion,if=buff.dancing_rune_weapon.up"
				,"dancing_rune_weapon,if=(!talent.blooddrinker.enabled|!cooldown.blooddrinker.ready)"
				,"tombstone,if=buff.bone_shield.stack>=7")

		-- Standard
		a.Flash("death_strike,if=damage_spike"
				,"death_strike,if=runic_power.deficit<10"
				,"blood_boil,if=!dot.blood_plague.ticking"
				,"blooddrinker,if=!buff.dancing_rune_weapon.up"
				,"marrowrend,if=buff.bone_shield.remains<=gcd*2"
				,"blood_boil,if=charges_fractional>=1.8&buff.haemostasis.stack<5&(buff.haemostasis.stack<3|!buff.dancing_rune_weapon.up)"
				,"marrowrend,if=(buff.bone_shield.stack<5&talent.ossuary.enabled)|buff.bone_shield.remains<gcd*3"
				,"bonestorm,if=runic_power>=100&spell_targets.bonestorm>=3"
				,"death_strike,if=buff.blood_shield.up|(runic_power.deficit<15&(runic_power.deficit<25|!buff.dancing_rune_weapon.up))"
				,"heart_strike,if=buff.dancing_rune_weapon.up"
				,"death_and_decay,if=buff.crimson_scourge.up"
				,"death_and_decay"
				,"heart_strike,if=rune.time_to_3<gcd|buff.bone_shield.stack>6")

	elseif x.Spec == 2 then
		-- Frost

		s.UpdateCooldown(152279, "Breath of Sindragosa")
		s.UpdateCooldown(51271, "Pillar of Frost")
		s.UpdateCooldown(47568, "Empower Rune Weapon")
		s.UpdateDoT(55095, "Frost Fever")
		s.UpdateBuff(194879, "Icy Talons")
		-- Apply Frost Fever and maintain Icy Talons
		if a.Flash("howling_blast,if=!dot.frost_fever.ticking&(!talent.breath_of_sindragosa.enabled|cooldown.breath_of_sindragosa.remains>15)"
				,"glacial_advance,if=buff.icy_talons.remains<=gcd&buff.icy_talons.up&spell_targets.glacial_advance>=2&(!talent.breath_of_sindragosa.enabled|cooldown.breath_of_sindragosa.remains>15)"
				,"frost_strike,if=buff.icy_talons.remains<=gcd&buff.icy_talons.up&(!talent.breath_of_sindragosa.enabled|cooldown.breath_of_sindragosa.remains>15)") then
			return
		end

		-- Cooldowns
		s.UpdateBuff(51271, "Pillar of Frost")
		s.UpdateBuff(47568, "Empower Rune Weapon")
		a.Flash("breath_of_sindragosa,if=cooldown.empower_rune_weapon.remains&cooldown.pillar_of_frost.remains"
				,"blood_fury,if=buff.pillar_of_frost.up&buff.empower_rune_weapon.up"
				,"berserking,if=buff.pillar_of_frost.up")

		if a.Flash("pillar_of_frost,if=cooldown.empower_rune_weapon.remains"
				,"empower_rune_weapon,if=cooldown.pillar_of_frost.ready&!talent.breath_of_sindragosa.enabled&rune.time_to_5>gcd&runic_power.deficit>=10"
				,"empower_rune_weapon,if=cooldown.pillar_of_frost.ready&talent.breath_of_sindragosa.enabled&rune>=3&runic_power>60") then
			return
		end
		s.UpdateBuff(235599, "cold_heart_item")
		s.UpdateBuff(281209, "cold_heart_talent")
		s.UpdateDebuff(51714, "Razorice")
		if (equipped.cold_heart or talent.cold_heart.enabled) and (((buff.cold_heart_item.stack >= 10 or buff.cold_heart_talent.stack >= 10) and debuff.razorice.stack == 5) or target.time_to_die <= x.MaxGCD) then
--				,"call_action_list,name=cold_heart,if=(equipped.cold_heart|talent.cold_heart.enabled)&(((buff.cold_heart_item.stack>=10|buff.cold_heart_talent.stack>=10)&debuff.razorice.stack=5)|target.time_to_die<=gcd)"
			-- Cold heart conditions
			s.UpdateCooldown(279302, "Frostwyrm's Fury")
			if a.Flash("chains_of_ice,if=(buff.cold_heart_item.stack>5|buff.cold_heart_talent.stack>5)&target.time_to_die<gcd"
					,"chains_of_ice,if=(buff.pillar_of_frost.remains<=gcd*(1+cooldown.frostwyrms_fury.ready)|buff.pillar_of_frost.remains<rune.time_to_3)&buff.pillar_of_frost.up") then
				return
			end
		end
		if a.Flash("frostwyrms_fury,if=(buff.pillar_of_frost.remains<=gcd&buff.pillar_of_frost.up)") then
			return
		end

		s.UpdateBuff(59052, "Rime")
		s.UpdateBuff(51124, "Killing Machine")
		if talent.breath_of_sindragosa.enabled and s.Boss("target") and cooldown.breath_of_sindragosa.remains < 5 then
			-- Breath of Sindragosa pooling rotation : starts 15s before the cd becomes available
			a.Flash("howling_blast,if=buff.rime.up"
					,"obliterate,if=rune.time_to_4<gcd&runic_power.deficit>=25"
					,"glacial_advance,if=runic_power.deficit<20&cooldown.pillar_of_frost.remains>rune.time_to_4"
					,"frost_strike,if=runic_power.deficit<20&cooldown.pillar_of_frost.remains>rune.time_to_4"
					,"frostscythe,if=buff.killing_machine.up&runic_power.deficit>(15+talent.runic_attenuation.enabled*3)"
					,"obliterate,if=runic_power.deficit>=(25+talent.runic_attenuation.enabled*3)"
					,"glacial_advance,if=cooldown.pillar_of_frost.remains>rune.time_to_4&runic_power.deficit<40&spell_targets.glacial_advance>=2"
					,"frost_strike,if=cooldown.pillar_of_frost.remains>rune.time_to_4&runic_power.deficit<40")
			return
		end
		s.UpdateBuff(152279, "Breath of Sindragosa")
		if buff.breath_of_sindragosa.up then
			-- Breath of Sindragosa ticking
			a.Flash("obliterate,if=runic_power<=30"
					,"remorseless_winter,if=talent.gathering_storm.enabled"
					,"howling_blast,if=buff.rime.up"
					,"obliterate,if=rune.time_to_5<gcd|runic_power<=45"
					,"frostscythe,if=buff.killing_machine.up"
					,"horn_of_winter,if=runic_power.deficit>=30&rune.time_to_3>gcd"
					,"remorseless_winter"
					,"frostscythe,if=spell_targets.frostscythe>=2"
					,"obliterate,if=runic_power.deficit>25|rune>3"
					,"arcane_torrent,if=runic_power.deficit>20")
		elseif buff.pillar_of_frost.up and talent.obliteration.enabled then
			-- Obliteration rotation
			a.Flash("remorseless_winter,if=talent.gathering_storm.enabled"
					,"obliterate,if=!talent.frostscythe.enabled&!buff.rime.up&spell_targets.howling_blast>=3"
					,"frostscythe,if=(buff.killing_machine.react|(buff.killing_machine.up&(prev_gcd.1.frost_strike|prev_gcd.1.howling_blast|prev_gcd.1.glacial_advance)))&(rune.time_to_4>gcd|spell_targets.frostscythe>=2)"
					,"obliterate,if=buff.killing_machine.react|(buff.killing_machine.up&(prev_gcd.1.frost_strike|prev_gcd.1.howling_blast|prev_gcd.1.glacial_advance))"
					,"glacial_advance,if=(!buff.rime.up|runic_power.deficit<10|rune.time_to_2>gcd)&spell_targets.glacial_advance>=2"
					,"howling_blast,if=buff.rime.up&spell_targets.howling_blast>=2"
					,"frost_strike,if=!buff.rime.up|runic_power.deficit<10|rune.time_to_2>gcd"
					,"howling_blast,if=buff.rime.up"
					,"obliterate")
		elseif x.ActiveEnemies >= 2 then
			-- AoE
			s.UpdateCooldown(196770, "Remorseless Winter")
			a.Flash("remorseless_winter,if=talent.gathering_storm.enabled"
					,"glacial_advance,if=talent.frostscythe.enabled"
					,"frost_strike,if=cooldown.remorseless_winter.remains<=2*gcd&talent.gathering_storm.enabled"
					,"howling_blast,if=buff.rime.up"
					,"frostscythe,if=buff.killing_machine.up"
					,"glacial_advance,if=runic_power.deficit<(15+talent.runic_attenuation.enabled*3)"
					,"frost_strike,if=runic_power.deficit<(15+talent.runic_attenuation.enabled*3)"
					,"remorseless_winter"
					,"frostscythe"
					,"obliterate,if=runic_power.deficit>(25+talent.runic_attenuation.enabled*3)"
					,"glacial_advance"
					,"frost_strike"
					,"horn_of_winter"
					,"arcane_torrent")
		else
			-- Standard rotation
			s.UpdateCooldown(196770, "Remorseless Winter")
			a.Flash("remorseless_winter"
					,"frost_strike,if=cooldown.remorseless_winter.remains<=2*gcd&talent.gathering_storm.enabled"
					,"howling_blast,if=buff.rime.up"
					,"obliterate,if=!buff.frozen_pulse.up&talent.frozen_pulse.enabled"
					,"frost_strike,if=runic_power.deficit<(15+talent.runic_attenuation.enabled*3)"
					,"frostscythe,if=buff.killing_machine.up&rune.time_to_4>=gcd"
					,"obliterate,if=runic_power.deficit>(25+talent.runic_attenuation.enabled*3)"
					,"frost_strike"
					,"horn_of_winter"
					,"arcane_torrent")
		end

	elseif x.Spec == 3 then
		-- Unholy

		s.UpdateCooldown(49206, "Summon Gargoyle")
		s.UpdateCooldown(63560, "Dark Transformation")
		s.UpdateCooldown(42650, "Army of the Dead")
		s.UpdateBuff(207289, "Unholy Frenzy")

		a.Flash("raise_dead")
		a.Flash("mind_freeze")

		x.Variables.pooling_for_gargoyle=(cooldown.summon_gargoyle.remains<5 and (cooldown.dark_transformation.remains < 5 or not equipped[137075])) and talent.summon_gargoyle.enabled

		-- Racials, Items, and other ogcds
		a.Flash("arcane_torrent,if=runic_power.deficit>65&(pet.gargoyle.active|!talent.summon_gargoyle.enabled)&rune.deficit>=5"
				,"blood_fury,if=pet.gargoyle.active|!talent.summon_gargoyle.enabled"
				,"berserking,if=pet.gargoyle.active|!talent.summon_gargoyle.enabled"
--				,"use_items"
--				,"use_item,name=feloiled_infernal_machine,if=pet.gargoyle.active|!talent.summon_gargoyle.enabled"
--				,"use_item,name=ring_of_collapsing_futures,if=(buff.temptation.stack=0&target.time_to_die>60)|target.time_to_die<60"
--				,"potion,if=cooldown.army_of_the_dead.ready|pet.gargoyle.active|buff.unholy_frenzy.up"
		)

		-- Maintain Virulent Plague
		s.UpdateDoT(191587, "Virulent Plague")
		if a.Flash("outbreak,target_if=(dot.virulent_plague.tick_time_remains+tick_time<=dot.virulent_plague.remains)&dot.virulent_plague.remains<=gcd") then
			return
		end

		-- Cold heart and other on-gcd cooldowns
		if equipped.cold_heart and buff.cold_heart_item.stack > 10 then
			-- Cold Heart legendary
			if a.Flash("chains_of_ice,if=buff.unholy_strength.remains<gcd&buff.unholy_strength.react&buff.cold_heart_item.stack>16"
						,"chains_of_ice,if=buff.master_of_ghouls.remains<gcd&buff.master_of_ghouls.up&buff.cold_heart_item.stack>17"
						,"chains_of_ice,if=buff.cold_heart_item.stack=20&buff.unholy_strength.react") then
				return
			end
		end
		s.UpdateDebuff(194310, "Festering Wound")
		s.UpdateCooldown(43265, "Death and Decay")
		s.UpdateCooldown(152280, "Defile")
		if a.Flash("army_of_the_dead"
				,"apocalypse,if=debuff.festering_wound.stack>=4"
				,"dark_transformation,if=(equipped.137075&cooldown.summon_gargoyle.remains>40)|(!equipped.137075|!talent.summon_gargoyle.enabled)"
				,"summon_gargoyle,if=runic_power.deficit<14"
				,"unholy_frenzy,if=debuff.festering_wound.stack<4"
				,"unholy_frenzy,if=active_enemies>=2&((cooldown.death_and_decay.remains<=gcd&!talent.defile.enabled)|(cooldown.defile.remains<=gcd&talent.defile.enabled))"
				,"soul_reaper,target_if=(target.time_to_die<8|rune<=2)&!buff.unholy_frenzy.up"
				,"unholy_blight") then
			return
		end

		s.UpdateBuff(81340, "Sudden Doom")
		s.UpdateCooldown(275699, "Apocalypse")
		if x.ActiveEnemies >= 2 then
			-- AoE rotation
			s.UpdateBuff(188290, "Death and Decay")
			a.Flash("death_and_decay,if=cooldown.apocalypse.remains"
					,"defile"
					,"epidemic,if=death_and_decay.ticking&rune<2&!variable.pooling_for_gargoyle"
					,"death_coil,if=death_and_decay.ticking&rune<2&!talent.epidemic.enabled&!variable.pooling_for_gargoyle"
					,"scourge_strike,if=death_and_decay.ticking&cooldown.apocalypse.remains"
					,"clawing_shadows,if=death_and_decay.ticking&cooldown.apocalypse.remains"
					,"epidemic,if=!variable.pooling_for_gargoyle"
					,"festering_strike,if=talent.bursting_sores.enabled&spell_targets.bursting_sores>=2&debuff.festering_wound.stack<=1"
					,"death_coil,if=buff.sudden_doom.react&rune.deficit>=4")
		else
			-- Generic
			a.Flash("death_coil,if=buff.sudden_doom.react&!variable.pooling_for_gargoyle|pet.gargoyle.active"
					,"death_coil,if=runic_power.deficit<14&(cooldown.apocalypse.remains>5|debuff.festering_wound.stack>4)&!variable.pooling_for_gargoyle"
					,"death_and_decay,if=talent.pestilence.enabled&cooldown.apocalypse.remains"
					,"defile,if=cooldown.apocalypse.remains"
					,"scourge_strike,if=((debuff.festering_wound.up&cooldown.apocalypse.remains>5)|debuff.festering_wound.stack>4)&cooldown.army_of_the_dead.remains>5"
					,"clawing_shadows,if=((debuff.festering_wound.up&cooldown.apocalypse.remains>5)|debuff.festering_wound.stack>4)&cooldown.army_of_the_dead.remains>5"
					,"death_coil,if=runic_power.deficit<20&!variable.pooling_for_gargoyle"
					,"festering_strike,if=((((debuff.festering_wound.stack<4&!buff.unholy_frenzy.up)|debuff.festering_wound.stack<3)&cooldown.apocalypse.remains<3)|debuff.festering_wound.stack<1)&cooldown.army_of_the_dead.remains>5"
					,"death_coil,if=!variable.pooling_for_gargoyle")
		end

	end
end)
